#include <math.h>

#define PI M_PI
#define BOHR 0.52918		// 0.52917724924
#define BOHR2 0.2800314724 	// BOHR^2 = 0.28002856111321308057
#define ROOM_TEMPERATURE 300	// instead of 298 due to empirical estimation

#define UED3  0		// approximation for low resolution
#define UED4  1
#define UED4L 1		// higher order term for large amplitude
#define SBINNING_UED3 0.02
#define SBINNING SBINNING_UED3
#define LEVELING INDEX_LEVELING_FIFJ
#define REFNUCLEI 'X'
#define DIVIDEDBYREFNUCLEI 1
#define INDIVIDUAL_TEMPERATURE 0

#define POLYNOMIAL   0
#define POLYNOMIALXE 1
#define RECIPROCAL   2
#define RECIPROCALXE 3
#define RECIPROCAL2  4

//#define PIXELSIZE 60.0		// UED3
//#define ElectronKineticEnergy 60.000	// UED3
#define PIXELSIZE 60.0			// UED4
#define ElectronKineticEnergy 60.000	// UED4
#define CameraDistance 25.0
#define ELECTRONBEAMSIZE 2
#define DAMPINGPARAMETER 0.005
#define FTF 1.0

//#define STEPSCALE 0.01
//#define STEPCAMERA STEPSCALE
#define STEPSCALE 0.05
#define STEPCAMERA 0.05

#define MAX_ITERATION 32 // 16	// 256
#define TOLERANCE_ZERO 1E-16
#define TOLERANCE_CAMERA 1E-8
#define TOLERANCE_FREQUENCY 1E-8

#define FSTFN(x)	log((x))
#define FSIFN(x)	exp((x))
